from h5py import File, Group
from thd_json import source
from h5schemas.scan_schema import open_schema
from h5schemas.initialize_dataset import initialize_dataset


def init_source(h5_file: File | Group):
    schema_groups = get_source_schemas()
    initialize_dataset(h5_file, schema_groups)


def get_source_schemas():
    return open_schema(source, "source.json")


def add_source_sample(h5_file: File | Group, current_ma: float, voltage_kv: float):
    dst = h5_file["current_ma"]
    dst.resize((dst.shape[0] + 1,))
    dst[-1,] = current_ma

    dst = h5_file["voltage_kv"]
    dst.resize((dst.shape[0] + 1,))
    dst[-1,] = voltage_kv


if __name__ == "__main__":
    test_file = File("./examples/source.h5", "w")
    init_source(test_file)

    add_source_sample(test_file, 1.0, 6.0)
    add_source_sample(test_file, 2.0, 7.0)
    add_source_sample(test_file, 3.0, 8.0)
